;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Yoshi's Island Ball 'n' Chain
; Programmed by SMWEdit
; modified and adapted for Tessera by imamelia
;
; Extra bytes: 1
;
; Extra byte 1:
; - Bit 0: Rotation direction. 0 = clockwise, 1 = counterclockwise.
; - Bit 1: Number of chains.  0 = single, 1 = double.
; - Bits 2-3: Unused.
; - Bits 4-5: Rotation speed (table index).
; - Bits 6-7: Unused.
;
; Known bugs: if it's about horizontal, and it goes off the side of the screen,
;             it will be considered off-screen before the whole thing passes by,
;             thus, the end of it seems to disappear.
;
; You will need to patch SMKDan's dsx.asm to your ROM with xkas
; this sprite, like all other dynamic sprites, uses the last 4 rows of sp4
;
; You will also need to patch my oampatch.asm to your ROM with xkas
; and use sprite header setting 10
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

incsrc subroutinedefs.asm

		!GFXADDR = $2D8000		; change this to where you inserted your GFX

		!OFFSET = $1528
		!FLIPXY = $1504
		!DIRECTION = $1602
		!FractionBits = $160E

		!GENERICTMP = $00
		!GENERICTMP2 = $02

		!SPRXTMP = $04
		!SPRYTMP = $06

		!FLIPXYTMP = $08

		!EXTRA_BITS = $7FAB10
		!EXTRAPROP1 = $7FAB28

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; INIT and MAIN JSL targets
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		Init:
		LDA $D8,x		; \
		SEC			;  | why do sprites
		SBC #$01		;  | always start out
		STA $D8,x		;  | one pixel below
		LDA $14D4,x		;  | where they are
		SBC #$00		;  | placed????
		STA $14D4,x		; /
		LDA $7FAB40,x
		AND #$01
		STA !DIRECTION,X
		RTL

		Main:
		JSR SPRITE_ROUTINE
		RTL     


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SPRITE_ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CHAIN1X:		db $00,$00,$FF,$FF,$FF,$FF,$FE,$FE,$FE,$FD,$FD,$FD,$FD,$FC,$FC,$FC
		db $FC,$FB,$FB,$FB,$FA,$FA,$FA,$FA,$F9,$F9,$F9,$F9,$F8,$F8,$F8,$F7
		db $F7,$F7,$F7,$F6,$F6,$F6,$F6,$F5,$F5,$F5,$F5,$F4,$F4,$F4,$F4,$F3
		db $F3,$F3,$F3,$F3,$F2,$F2,$F2,$F2,$F1,$F1,$F1,$F1,$F1,$F0,$F0,$F0
		db $F0,$F0,$EF,$EF,$EF,$EF,$EF,$EE,$EE,$EE,$EE,$EE,$EE,$ED,$ED,$ED
		db $ED,$ED,$ED,$EC,$EC,$EC,$EC,$EC,$EC,$EC,$EB,$EB,$EB,$EB,$EB,$EB
		db $EB,$EB,$EB,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$E9
		db $E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9
		db $E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9
		db $E9,$E9,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$EB,$EB
		db $EB,$EB,$EB,$EB,$EB,$EB,$EB,$EC,$EC,$EC,$EC,$EC,$EC,$EC,$ED,$ED
		db $ED,$ED,$ED,$ED,$EE,$EE,$EE,$EE,$EE,$EE,$EF,$EF,$EF,$EF,$EF,$F0
		db $F0,$F0,$F0,$F0,$F1,$F1,$F1,$F1,$F1,$F2,$F2,$F2,$F2,$F3,$F3,$F3
		db $F3,$F3,$F4,$F4,$F4,$F4,$F5,$F5,$F5,$F5,$F6,$F6,$F6,$F6,$F7,$F7
		db $F7,$F7,$F8,$F8,$F8,$F9,$F9,$F9,$F9,$FA,$FA,$FA,$FA,$FB,$FB,$FB
		db $FC,$FC,$FC,$FC,$FD,$FD,$FD,$FD,$FE,$FE,$FE,$FF,$FF,$FF,$FF,$00

CHAIN1Y:		db $17,$17,$17,$17,$17,$17,$17,$17,$17,$17,$17,$17,$17,$17,$17,$17
		db $17,$17,$16,$16,$16,$16,$16,$16,$16,$16,$16,$16,$16,$16,$15,$15
		db $15,$15,$15,$15,$15,$15,$15,$14,$14,$14,$14,$14,$14,$14,$13,$13
		db $13,$13,$13,$13,$12,$12,$12,$12,$12,$12,$11,$11,$11,$11,$11,$10
		db $10,$10,$10,$10,$0F,$0F,$0F,$0F,$0F,$0E,$0E,$0E,$0E,$0D,$0D,$0D
		db $0D,$0D,$0C,$0C,$0C,$0C,$0B,$0B,$0B,$0B,$0A,$0A,$0A,$0A,$09,$09
		db $09,$09,$08,$08,$08,$07,$07,$07,$07,$06,$06,$06,$06,$05,$05,$05
		db $04,$04,$04,$04,$03,$03,$03,$03,$02,$02,$02,$01,$01,$01,$01,$00
		db $00,$00,$FF,$FF,$FF,$FF,$FE,$FE,$FE,$FD,$FD,$FD,$FD,$FC,$FC,$FC
		db $FC,$FB,$FB,$FB,$FA,$FA,$FA,$FA,$F9,$F9,$F9,$F9,$F8,$F8,$F8,$F7
		db $F7,$F7,$F7,$F6,$F6,$F6,$F6,$F5,$F5,$F5,$F5,$F4,$F4,$F4,$F4,$F3
		db $F3,$F3,$F3,$F3,$F2,$F2,$F2,$F2,$F1,$F1,$F1,$F1,$F1,$F0,$F0,$F0
		db $F0,$F0,$EF,$EF,$EF,$EF,$EF,$EE,$EE,$EE,$EE,$EE,$EE,$ED,$ED,$ED
		db $ED,$ED,$ED,$EC,$EC,$EC,$EC,$EC,$EC,$EC,$EB,$EB,$EB,$EB,$EB,$EB
		db $EB,$EB,$EB,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$EA,$E9
		db $E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9,$E9

CHAIN2X:		db $00,$FF,$FF,$FE,$FD,$FD,$FC,$FC,$FB,$FA,$FA,$F9,$F9,$F8,$F7,$F7
		db $F6,$F5,$F5,$F4,$F4,$F3,$F2,$F2,$F1,$F1,$F0,$EF,$EF,$EE,$EE,$ED
		db $EC,$EC,$EB,$EB,$EA,$EA,$E9,$E9,$E8,$E7,$E7,$E6,$E6,$E5,$E5,$E4
		db $E4,$E3,$E3,$E2,$E2,$E1,$E1,$E0,$E0,$DF,$DF,$DE,$DE,$DD,$DD,$DC
		db $DC,$DB,$DB,$DB,$DA,$DA,$D9,$D9,$D9,$D8,$D8,$D7,$D7,$D7,$D6,$D6
		db $D6,$D5,$D5,$D5,$D4,$D4,$D4,$D3,$D3,$D3,$D2,$D2,$D2,$D2,$D1,$D1
		db $D1,$D1,$D0,$D0,$D0,$D0,$D0,$CF,$CF,$CF,$CF,$CF,$CF,$CE,$CE,$CE
		db $CE,$CE,$CE,$CE,$CE,$CD,$CD,$CD,$CD,$CD,$CD,$CD,$CD,$CD,$CD,$CD
		db $CD,$CD,$CD,$CD,$CD,$CD,$CD,$CD,$CD,$CD,$CD,$CD,$CE,$CE,$CE,$CE
		db $CE,$CE,$CE,$CE,$CF,$CF,$CF,$CF,$CF,$CF,$D0,$D0,$D0,$D0,$D0,$D1
		db $D1,$D1,$D1,$D2,$D2,$D2,$D2,$D3,$D3,$D3,$D4,$D4,$D4,$D5,$D5,$D5
		db $D6,$D6,$D6,$D7,$D7,$D7,$D8,$D8,$D9,$D9,$D9,$DA,$DA,$DB,$DB,$DB
		db $DC,$DC,$DD,$DD,$DE,$DE,$DF,$DF,$E0,$E0,$E1,$E1,$E2,$E2,$E3,$E3
		db $E4,$E4,$E5,$E5,$E6,$E6,$E7,$E7,$E8,$E9,$E9,$EA,$EA,$EB,$EB,$EC
		db $EC,$ED,$EE,$EE,$EF,$EF,$F0,$F1,$F1,$F2,$F2,$F3,$F4,$F4,$F5,$F5
		db $F6,$F7,$F7,$F8,$F9,$F9,$FA,$FA,$FB,$FC,$FC,$FD,$FD,$FE,$FF,$FF

CHAIN2Y:		db $33,$33,$33,$33,$33,$33,$33,$33,$33,$33,$33,$33,$32,$32,$32,$32
		db $32,$32,$32,$32,$31,$31,$31,$31,$31,$31,$30,$30,$30,$30,$30,$2F
		db $2F,$2F,$2F,$2E,$2E,$2E,$2E,$2D,$2D,$2D,$2C,$2C,$2C,$2B,$2B,$2B
		db $2A,$2A,$2A,$29,$29,$29,$28,$28,$27,$27,$27,$26,$26,$25,$25,$25
		db $24,$24,$23,$23,$22,$22,$21,$21,$20,$20,$1F,$1F,$1E,$1E,$1D,$1D
		db $1C,$1C,$1B,$1B,$1A,$1A,$19,$19,$18,$17,$17,$16,$16,$15,$15,$14
		db $14,$13,$12,$12,$11,$11,$10,$0F,$0F,$0E,$0E,$0D,$0C,$0C,$0B,$0B
		db $0A,$09,$09,$08,$07,$07,$06,$06,$05,$04,$04,$03,$03,$02,$01,$01
		db $00,$FF,$FF,$FE,$FD,$FD,$FC,$FC,$FB,$FA,$FA,$F9,$F9,$F8,$F7,$F7
		db $F6,$F5,$F5,$F4,$F4,$F3,$F2,$F2,$F1,$F1,$F0,$EF,$EF,$EE,$EE,$ED
		db $EC,$EC,$EB,$EB,$EA,$EA,$E9,$E9,$E8,$E7,$E7,$E6,$E6,$E5,$E5,$E4
		db $E4,$E3,$E3,$E2,$E2,$E1,$E1,$E0,$E0,$DF,$DF,$DE,$DE,$DD,$DD,$DC
		db $DC,$DB,$DB,$DB,$DA,$DA,$D9,$D9,$D9,$D8,$D8,$D7,$D7,$D7,$D6,$D6
		db $D6,$D5,$D5,$D5,$D4,$D4,$D4,$D3,$D3,$D3,$D2,$D2,$D2,$D2,$D1,$D1
		db $D1,$D1,$D0,$D0,$D0,$D0,$D0,$CF,$CF,$CF,$CF,$CF,$CF,$CE,$CE,$CE
		db $CE,$CE,$CE,$CE,$CE,$CD,$CD,$CD,$CD,$CD,$CD,$CD,$CD,$CD,$CD,$CD

BALL_X:		db $00,$FF,$FE,$FD,$FC,$FB,$FA,$F9,$F8,$F7,$F6,$F5,$F4,$F3,$F2,$F2
		db $F1,$F0,$EF,$EE,$ED,$EC,$EB,$EA,$E9,$E8,$E7,$E6,$E5,$E4,$E4,$E3
		db $E2,$E1,$E0,$DF,$DE,$DD,$DC,$DC,$DB,$DA,$D9,$D8,$D7,$D7,$D6,$D5
		db $D4,$D3,$D3,$D2,$D1,$D0,$CF,$CF,$CE,$CD,$CC,$CC,$CB,$CA,$CA,$C9
		db $C8,$C7,$C7,$C6,$C5,$C5,$C4,$C4,$C3,$C2,$C2,$C1,$C1,$C0,$BF,$BF
		db $BE,$BE,$BD,$BD,$BC,$BC,$BB,$BB,$BA,$BA,$B9,$B9,$B9,$B8,$B8,$B7
		db $B7,$B7,$B6,$B6,$B6,$B5,$B5,$B5,$B4,$B4,$B4,$B4,$B3,$B3,$B3,$B3
		db $B3,$B2,$B2,$B2,$B2,$B2,$B2,$B1,$B1,$B1,$B1,$B1,$B1,$B1,$B1,$B1
		db $B1,$B1,$B1,$B1,$B1,$B1,$B1,$B1,$B1,$B1,$B2,$B2,$B2,$B2,$B2,$B2
		db $B3,$B3,$B3,$B3,$B3,$B4,$B4,$B4,$B4,$B5,$B5,$B5,$B6,$B6,$B6,$B7
		db $B7,$B7,$B8,$B8,$B9,$B9,$B9,$BA,$BA,$BB,$BB,$BC,$BC,$BD,$BD,$BE
		db $BE,$BF,$BF,$C0,$C1,$C1,$C2,$C2,$C3,$C4,$C4,$C5,$C5,$C6,$C7,$C7
		db $C8,$C9,$CA,$CA,$CB,$CC,$CC,$CD,$CE,$CF,$CF,$D0,$D1,$D2,$D3,$D3
		db $D4,$D5,$D6,$D7,$D7,$D8,$D9,$DA,$DB,$DC,$DC,$DD,$DE,$DF,$E0,$E1
		db $E2,$E3,$E4,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF,$F0
		db $F1,$F2,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF

BALL_Y:		db $4F,$4F,$4F,$4F,$4F,$4F,$4F,$4F,$4F,$4F,$4E,$4E,$4E,$4E,$4E,$4E
		db $4D,$4D,$4D,$4D,$4D,$4C,$4C,$4C,$4C,$4B,$4B,$4B,$4A,$4A,$4A,$49
		db $49,$49,$48,$48,$47,$47,$47,$46,$46,$45,$45,$44,$44,$43,$43,$42
		db $42,$41,$41,$40,$3F,$3F,$3E,$3E,$3D,$3C,$3C,$3B,$3B,$3A,$39,$39
		db $38,$37,$36,$36,$35,$34,$34,$33,$32,$31,$31,$30,$2F,$2E,$2D,$2D
		db $2C,$2B,$2A,$29,$29,$28,$27,$26,$25,$24,$24,$23,$22,$21,$20,$1F
		db $1E,$1D,$1C,$1C,$1B,$1A,$19,$18,$17,$16,$15,$14,$13,$12,$11,$10
		db $0F,$0E,$0E,$0D,$0C,$0B,$0A,$09,$08,$07,$06,$05,$04,$03,$02,$01
		db $00,$FF,$FE,$FD,$FC,$FB,$FA,$F9,$F8,$F7,$F6,$F5,$F4,$F3,$F2,$F2
		db $F1,$F0,$EF,$EE,$ED,$EC,$EB,$EA,$E9,$E8,$E7,$E6,$E5,$E4,$E4,$E3
		db $E2,$E1,$E0,$DF,$DE,$DD,$DC,$DC,$DB,$DA,$D9,$D8,$D7,$D7,$D6,$D5
		db $D4,$D3,$D3,$D2,$D1,$D0,$CF,$CF,$CE,$CD,$CC,$CC,$CB,$CA,$CA,$C9
		db $C8,$C7,$C7,$C6,$C5,$C5,$C4,$C4,$C3,$C2,$C2,$C1,$C1,$C0,$BF,$BF
		db $BE,$BE,$BD,$BD,$BC,$BC,$BB,$BB,$BA,$BA,$B9,$B9,$B9,$B8,$B8,$B7
		db $B7,$B7,$B6,$B6,$B6,$B5,$B5,$B5,$B4,$B4,$B4,$B4,$B3,$B3,$B3,$B3
		db $B3,$B2,$B2,$B2,$B2,$B2,$B2,$B1,$B1,$B1,$B1,$B1,$B1,$B1,$B1,$B1

CHAIN1XH:	db $00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$00

CHAIN1YH:	db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

CHAIN2XH:	db $00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

CHAIN2YH:	db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

BALL_XH:		db $00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

BALL_YH:		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
		db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

; how fast it rotates - default speed is 0100; higher values are faster, and lower values are slower
RotationSpeed:
dw $0100,$0080,$0200,$0180

RETURN1:		RTS

SPRITE_ROUTINE:	JSR SUB_GFX
		LDA $14C8,x		; \  return if
		CMP #$08		;  | sprite
		BNE RETURN1		; /  status != 8
		LDA $9D			; \ return if
		BNE RETURN1		; / sprites locked
		JSL !SubOffscreenX0	; only process sprite while on screen

		LDA $7FAB40,x
		AND #$30
		LSR #3
		TAY
		LDA RotationSpeed,y
		STA $00
		LDA RotationSpeed+1,y
		STA $01

		LDA !DIRECTION,x		; \ CW or
		BEQ CLOCKWISE		; / CCW?
CCLOCKWISE:
		LDA !FractionBits,x
		SEC
		SBC $00
		STA !FractionBits,x
		LDA !OFFSET,x			; negative rotation
		SBC $01
		STA !OFFSET,x			;  | MAX rotation
		BCS AFTERROTATE		;  | is when sprite
		LDA !FLIPXY,x		;  | must rotate
		EOR.b #%00000001		;  | 180 degrees
		STA !FLIPXY,x		; /
		BRA AFTERROTATE		; skip CW code
CLOCKWISE:	LDA !FractionBits,x
		CLC
		ADC $00
		STA !FractionBits,x
		LDA !OFFSET,x			; positive rotation
		ADC $01
		STA !OFFSET,x
		BCC AFTERROTATE
		LDA !FLIPXY,x		;  | MIN rotation is
		EOR.b #%00000001		;  | when to rotate 180
		STA !FLIPXY,x		; /
AFTERROTATE:

		LDA $14			; \
		AND.b #%00000111		;  | do sound effect
		BNE NO_SOUND		;  | (copied from grinder
		LDA #$04		;  | and slightly modified)
		STA $1DFA		; /
NO_SOUND:

		LDA !FLIPXY,x		; \ scratch RAM used for interaction
		STA !FLIPXYTMP		; / to determine if rotated extra 180
		JSR XTRAINTERACTION	; interact with chain segment 1, chain segment 2, ball
		LDA $7FAB40,x	; \
		AND.b #%00000010		;  | bit 1 of extra byte 1 not set -> no extra flip-side ball 'n' chain
		BEQ NO_FLIPSIDE_BNC	; /
		LDA !FLIPXY,x		; \  put opposite
		EOR.b #%00000001		;  | side into
		STA !FLIPXYTMP		; /  rot180 temp RAM
		JSR XTRAINTERACTION	; interact with ball 'n' chain on other side
NO_FLIPSIDE_BNC:

RETURN:		RTS

M_INTERACT:	LDA $187A		; \ normal mario interact
		BEQ NORMALINTERACT	; / if not riding Yoshi
		LDA $77			; \  process lose
		AND.b #%00000100		;  | Yoshi interaction
		BNE YOSHI_INTERACT	; /  if on ground
		LDA $7D			; \ else if going down
		BPL NORMALINTERACT	; / do normal interaction
YOSHI_INTERACT:	LDA.w $1490		; \ Branch if 
		BNE NO_INTERACT		; / Mario has star
		LDA $167A,x		; \
		PHA			;  | set "no default interaction"
		ORA.b #%10000000		;  | flag temporarily and back-up
		STA $167A,x		; /
		JSL $81A7DC		; detect if mario not touching
		PLA			; \ load backed up
		STA $167A,x		; / interact flag
		BCC NO_INTERACT		; mario not touching, don't hurt him
		JSR LOSEYOSHI		; lose yoshi
NO_INTERACT:	RTS
NORMALINTERACT:	JSL $81A7DC		; normal interact with mario
		RTS

;; RIPPED AND MODIFIED FROM SNES $02:A469
LOSEYOSHI:	PHX
		LDX.w $18DF
		LDA.b #$10
		STA.w $163D,X
		LDA.b #$03		; \ Play sound effect 
		STA.w $1DFA		; / 
		LDA.b #$13		; \ Play sound effect 
		STA.w $1DFC		; / 
		LDA.b #$02
		STA $C1,X
		STZ.w $187A
		STZ.w $0DC1
		LDA.b #$C0
		STA $7D
		STZ $7B
		LDY.w $157B,X
		PHX
		TYX
		LDA.l $82A4B3,X
		PLX
		STA $B5,X
		STZ.w $1593,X
		STZ.w $151B,X
		STZ.w $18AE
		LDA.b #$30
		STA.w $1497
		PLX
Return02A4AD:	RTS                       ; Return

XTRAINTERACTION:
		LDA $E4,x		; \
		STA !SPRXTMP		;  | store sprite X
		LDA $14E0,x		;  | and Y position
		STA !SPRXTMP+1		;  | into scratch
		LDA $D8,x		;  | RAM for use
		STA !SPRYTMP		;  | in some of the
		LDA $14D4,x		;  | following code
		STA !SPRYTMP+1		; /
		LDA $E4,x		; \
		PHA			;  | back up sprite's
		LDA $14E0,x		;  | position so I
		PHA			;  | can shift it
		LDA $D8,x		;  | around temporarily
		PHA			;  |
		LDA $14D4,x		;  |
		PHA			; /
		LDY !FLIPXYTMP		; load sprite flip into Y register
		LDA !OFFSET,x		; load frame offset into A
		PHX			; back up X (index in sprite tables)
		TAX			; transfer A (offset) into X
		CPY #$00		; \ decide whether to add or subtract
		BNE NOSWITCHOFFI	; / offsets based on direction
SWITCHOFFI:	LDA !SPRXTMP		; \
		SEC			;  | subtract
		SBC.w CHAIN1X,x		;  | X coordinates
		STA !GENERICTMP		;  |
		LDA !SPRXTMP+1		;  |
		SBC.w CHAIN1XH,x		;  |
		STA !GENERICTMP+1	; /
		BRA ENDOFFSWITCHI	; banch to after following code
NOSWITCHOFFI:	LDA !SPRXTMP		; \
		CLC			;  | add X coordinates
		ADC.w CHAIN1X,x		;  | to sprite's
		STA !GENERICTMP		;  | X position
		LDA !SPRXTMP+1		;  | and store into
		ADC.w CHAIN1XH,x		;  | scratch RAM
		STA !GENERICTMP+1	; /
ENDOFFSWITCHI:	PLX			; load backed up X
		LDA !GENERICTMP		; \
		STA $E4,x		;  | transfer shifted X
		LDA !GENERICTMP+1	;  | to sprite's X
		STA $14E0,x		; /
		LDY !FLIPXYTMP		; load sprite flip into Y register
		LDA !OFFSET,x		; load frame offset into A
		PHX			; back up X (index in sprite tables)
		TAX			; transfer A (offset) into X
		CPY #$00		; \ decide whether to add or subtract
		BNE NOSWITCHOFFI2	; / offsets based on extra bit
SWITCHOFFI2:	LDA !SPRYTMP		; \
		SEC			;  |subtract
		SBC.w CHAIN1Y,x		;  | Y coordinates
		STA !GENERICTMP2		;  |
		LDA !SPRYTMP+1		;  |
		SBC.w CHAIN1YH,x		;  |
		STA !GENERICTMP2+1	; /
		BRA ENDOFFSWITCHI2	; banch to after following code
NOSWITCHOFFI2:	LDA !SPRYTMP		; \
		CLC			;  | add Y coordinates
		ADC.w CHAIN1Y,x		;  | to sprite's
		STA !GENERICTMP2		;  | Y position
		LDA !SPRYTMP+1		;  | and store into
		ADC.w CHAIN1YH,x		;  | scratch RAM
		STA !GENERICTMP2+1	; /
ENDOFFSWITCHI2:	PLX			; load backed up X
		LDA !GENERICTMP2		; load shifted Y low byte
		STA $D8,x		; store into sprite's Y low
		LDA !GENERICTMP2+1	; load shifted Y high byte
		STA $14D4,x		; store shifted high byte
		LDA $D8,x		; \
		SEC			;  | since 32x32
		SBC #$08		;  | clipping
		STA $D8,x		;  | field starts
		LDA $14D4,x		;  | at top-left
		SBC #$00		;  | corner, shift
		STA $14D4,x		;  | from center
		LDA $E4,x		;  | 16x16 to corner
		SEC			;  | for 32x32
		SBC #$08		;  | interaction
		STA $E4,x		;  |
		LDA $14E0,x		;  |
		SBC #$00		;  |
		STA $14E0,x		; /
		LDA !FLIPXYTMP		; \ back up 180 rotation
		PHA			; / scratch RAM
		JSR M_INTERACT		; add a mario interaction field to shifted position
		PLA			; \ load backed up 180
		STA !FLIPXYTMP		; / rotation scratch RAM
		PLA			; \
		STA $14D4,x		;  | load backed up
		PLA			;  | sprite position
		STA $D8,x		;  |
		PLA			;  |
		STA $14E0,x		;  |
		PLA			;  |
		STA $E4,x		; /
		LDA $E4,x		; \
		STA !SPRXTMP		;  | store sprite X
		LDA $14E0,x		;  | and Y position
		STA !SPRXTMP+1		;  | into scratch
		LDA $D8,x		;  | RAM for use
		STA !SPRYTMP		;  | in some of the
		LDA $14D4,x		;  | following code
		STA !SPRYTMP+1		; /
		LDA $E4,x		; \
		PHA			;  | back up sprite's
		LDA $14E0,x		;  | position so I
		PHA			;  | can shift it
		LDA $D8,x		;  | around temporarily
		PHA			;  |
		LDA $14D4,x		;  |
		PHA			; /
		LDY !FLIPXYTMP		; load sprite flip into Y register
		LDA !OFFSET,x		; load frame offset into A
		PHX			; back up X (index in sprite tables)
		TAX			; transfer A (offset) into X
		CPY #$00		; \ decide whether to add or subtract
		BNE NOSWITCHOFFIB	; / offsets based on direction
SWITCHOFFIB:	LDA !SPRXTMP		; \
		SEC			;  | facing right, so subtract
		SBC.w CHAIN2X,x		;  | X coordinates (since they
		STA !GENERICTMP		;  | are negative)
		LDA !SPRXTMP+1		;  |
		SBC.w CHAIN2XH,x		;  |
		STA !GENERICTMP+1	; /
		BRA ENDOFFSWITCHIB	; banch to after following code
NOSWITCHOFFIB:	LDA !SPRXTMP		; \
		CLC			;  | add X coordinates
		ADC.w CHAIN2X,x		;  | to sprite's
		STA !GENERICTMP		;  | X position
		LDA !SPRXTMP+1		;  | and store into
		ADC.w CHAIN2XH,x		;  | scratch RAM
		STA !GENERICTMP+1	; /
ENDOFFSWITCHIB:	PLX			; load backed up X
		LDA !GENERICTMP		; \
		STA $E4,x		;  | transfer shifted X
		LDA !GENERICTMP+1	;  | to sprite's X
		STA $14E0,x		; /
		LDY !FLIPXYTMP		; load sprite flip into Y register
		LDA !OFFSET,x		; load frame offset into A
		PHX			; back up X (index in sprite tables)
		TAX			; transfer A (offset) into X
		CPY #$00		; \ decide whether to add or subtract
		BNE NOSWITCHOFFI2B	; / offsets based on extra bit
SWITCHOFFI2B:	LDA !SPRYTMP		; \
		SEC			;  | subtract
		SBC.w CHAIN2Y,x		;  | Y coordinates
		STA !GENERICTMP2		;  |
		LDA !SPRYTMP+1		;  |
		SBC.w CHAIN2YH,x		;  |
		STA !GENERICTMP2+1	; /
		BRA ENDOFFSWITCHI2B	; banch to after following code
NOSWITCHOFFI2B:	LDA !SPRYTMP		; \
		CLC			;  | add Y coordinates
		ADC.w CHAIN2Y,x		;  | to sprite's
		STA !GENERICTMP2		;  | Y position
		LDA !SPRYTMP+1		;  | and store into
		ADC.w CHAIN2YH,x		;  | scratch RAM
		STA !GENERICTMP2+1	; /
ENDOFFSWITCHI2B:	PLX			; load backed up X
		LDA !GENERICTMP2		; load shifted Y low byte
		STA $D8,x		; store into sprite's Y low
		LDA !GENERICTMP2+1	; load shifted Y high byte
		STA $14D4,x		; store shifted high byte
		LDA $D8,x		; \
		SEC			;  | since 32x32
		SBC #$08		;  | clipping
		STA $D8,x		;  | field starts
		LDA $14D4,x		;  | at top-left
		SBC #$00		;  | corner, shift
		STA $14D4,x		;  | from center
		LDA $E4,x		;  | 16x16 to corner
		SEC			;  | for 32x32
		SBC #$08		;  | interaction
		STA $E4,x		;  |
		LDA $14E0,x		;  |
		SBC #$00		;  |
		STA $14E0,x		; /
		LDA !FLIPXYTMP		; \ back up 180 rotation
		PHA			; / scratch RAM
		JSR M_INTERACT		; add a mario interaction field to shifted position
		PLA			; \ load backed up 180
		STA !FLIPXYTMP		; / rotation scratch RAM
		PLA			; \
		STA $14D4,x		;  | load backed up
		PLA			;  | sprite position
		STA $D8,x		;  |
		PLA			;  |
		STA $14E0,x		;  |
		PLA			;  |
		STA $E4,x		; /
		LDA $E4,x		; \
		STA !SPRXTMP		;  | store sprite X
		LDA $14E0,x		;  | and Y position
		STA !SPRXTMP+1		;  | into scratch
		LDA $D8,x		;  | RAM for use
		STA !SPRYTMP		;  | in some of the
		LDA $14D4,x		;  | following code
		STA !SPRYTMP+1		; /
		LDA $E4,x		; \
		PHA			;  | back up sprite's
		LDA $14E0,x		;  | position so I
		PHA			;  | can shift it
		LDA $D8,x		;  | around temporarily
		PHA			;  |
		LDA $14D4,x		;  |
		PHA			; /
		LDY !FLIPXYTMP		; load sprite flip into Y register
		LDA !OFFSET,x		; load frame offset into A
		PHX			; back up X (index in sprite tables)
		TAX			; transfer A (offset) into X
		CPY #$00		; \ decide whether to add or subtract
		BNE NOSWITCHOFFIC	; / offsets based on direction
SWITCHOFFIC:	LDA !SPRXTMP		; \
		SEC			;  | facing right, so subtract
		SBC.w BALL_X,x		;  | X coordinates (since they
		STA !GENERICTMP		;  | are negative)
		LDA !SPRXTMP+1		;  |
		SBC.w BALL_XH,x		;  |
		STA !GENERICTMP+1	; /
		BRA ENDOFFSWITCHIC	; banch to after following code
NOSWITCHOFFIC:	LDA !SPRXTMP		; \
		CLC			;  | add X coordinates
		ADC.w BALL_X,x		;  | to sprite's
		STA !GENERICTMP		;  | X position
		LDA !SPRXTMP+1		;  | and store into
		ADC.w BALL_XH,x		;  | scratch RAM
		STA !GENERICTMP+1	; /
ENDOFFSWITCHIC:	PLX			; load backed up X
		LDA !GENERICTMP		; \
		STA $E4,x		;  | transfer shifted X
		LDA !GENERICTMP+1	;  | to sprite's X
		STA $14E0,x		; /
		LDY !FLIPXYTMP		; load sprite flip into Y register
		LDA !OFFSET,x		; load frame offset into A
		PHX			; back up X (index in sprite tables)
		TAX			; transfer A (offset) into X
		CPY #$00		; \ decide whether to add or subtract
		BNE NOSWITCHOFFI2C	; / offsets based on extra bit
SWITCHOFFI2C:	LDA !SPRYTMP		; \
		SEC			;  | subtract
		SBC.w BALL_Y,x		;  | Y coordinates
		STA !GENERICTMP2		;  |
		LDA !SPRYTMP+1		;  |
		SBC.w BALL_YH,x		;  |
		STA !GENERICTMP2+1	; /
		BRA ENDOFFSWITCHI2C	; banch to after following code
NOSWITCHOFFI2C:	LDA !SPRYTMP		; \
		CLC			;  | add Y coordinates
		ADC.w BALL_Y,x		;  | to sprite's
		STA !GENERICTMP2		;  | Y position
		LDA !SPRYTMP+1		;  | and store into
		ADC.w BALL_YH,x		;  | scratch RAM
		STA !GENERICTMP2+1	; /
ENDOFFSWITCHI2C:	PLX			; load backed up X
		LDA !GENERICTMP2		; load shifted Y low byte
		STA $D8,x		; store into sprite's Y low
		LDA !GENERICTMP2+1	; load shifted Y high byte
		STA $14D4,x		; store shifted high byte
		LDA $D8,x		; \
		SEC			;  | since 32x32
		SBC #$08		;  | clipping
		STA $D8,x		;  | field starts
		LDA $14D4,x		;  | at top-left
		SBC #$00		;  | corner, shift
		STA $14D4,x		;  | from center
		LDA $E4,x		;  | 16x16 to corner
		SEC			;  | for 32x32
		SBC #$08		;  | interaction
		STA $E4,x		;  |
		LDA $14E0,x		;  |
		SBC #$00		;  |
		STA $14E0,x		; /
		JSR M_INTERACT		; add a mario interaction field to shifted position
		PLA			; \
		STA $14D4,x		;  | load backed up
		PLA			;  | sprite position
		STA $D8,x		;  |
		PLA			;  |
		STA $14E0,x		;  |
		PLA			;  |
		STA $E4,x		; /
		RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GRAPHICS ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!TILESDRAWN = $08
!TEMP_FOR_TILE = $03
!TEMP_FOR_TILE_2 = $04

!TEMP = $09
!BANKTEMP = $07

!SLOTPTR = $0660		;16bit pointer for source GFX
!SLOTBANK = $0662	;bank
!SLOTDEST = $06FC	;VRAM address
!SLOTSUSED = $06FE	;how many slots have been used

!MAXSLOTS = $04		;maximum selected slots

DNMC_TILES:	db $00,$02,$20,$22
DNMC_XPOS:	db $F8,$08,$F8,$08
DNMC_YPOS:	db $F8,$F8,$08,$08

SUB_GFX:		JSL !GetDrawInfo	; get info to draw tiles
		STZ !TILESDRAWN		; zero tiles drawn
		STZ !BANKTEMP		; relative chain ROM bank is zero
		LDA !OFFSET,x		; \
		LSR A			;  | frame# is offset/4
		LSR A			; /
		JSR OFF2FRM		; convert frame# to frame pointer
		JSR GETSLOT		; call routine to get a slot
		STA !TEMP_FOR_TILE	; store tile into scratch RAM
		LDA #$01		; \ relative ball
		STA !BANKTEMP		; / ROM bank is 1
		LDA !OFFSET,x		; \
		LSR A			;  | frame# is offset/4
		LSR A			; /
		JSR OFF2FRM		; convert frame# to frame pointer
		JSR GETSLOT		; call routine to get a slot
		STA !TEMP_FOR_TILE_2	; store tile into scratch RAM
		LDA !FLIPXY,x		; \ 180 rotation status
		STA $02			; / goes to scratch RAM
		JSR SUB_GFX_2		; draw all GFX
		LDA $7FAB40,x	; \
		AND.b #%00000010		;  | skip flipped GFX if bit 1 of extra byte not set
		BEQ SET_T		; /
		LDA !FLIPXY,x		; \  inverse of 180
		EOR.b #%00000001		;  | degree rotation status
		STA $02			; /  goes to scratch RAM
		JSR SUB_GFX_2		; draw all GFX
SET_T:		JSR SETTILES		; set tiles / don't draw offscreen
ENDSUB:		RTS

SUB_GFX_2:	LDA !TEMP_FOR_TILE_2	; load tile number for ball
		BEQ CHAIN		; if it doesn't exist, skip and go to chain
		JSR DRAW_BALL		; draw the ball
CHAIN:		LDA !TEMP_FOR_TILE	; load tile number for chains
		BEQ ENDSUB2		; if it doesn't exist, skip and return
		JSR DRAW_CHAIN1		; draw chain piece 1
		JSR DRAW_CHAIN2		; draw chain piece 2
ENDSUB2:		RTS

DRAW_CHAIN1:	PHX			; back up X
		LDX #$00		; load X with zero
TILELP:		CPX #$04		; end of loop?
		BNE NORETFRML		; if not, then don't end
		JMP RETFRML		; if so, then JMP to end (BRA is out of range)
NORETFRML:
		LDA $00			; get sprite's X position
		PHY			; \
		LDY $02			;  | offset by
		BNE NO_FLIP_1C		;  | this tile's
		SEC			;  | X position
		SBC.w DNMC_XPOS,x		;  | (add or
		BRA END_FLIP_1C		;  | subtract
NO_FLIP_1C:	CLC			;  | depending on
		ADC.w DNMC_XPOS,x		;  | flip)
END_FLIP_1C:	PLY			; /
		PHX			; \
		LDX $15E9		;  | offset by
		PHA			;  | chain's X
		LDA !OFFSET,x		;  | position
		TAX			;  | (add or
		PLA			;  | subtract
		PHY			;  | depending on
		LDY $02			;  | direction)
		BNE NOSWITCHC1OFF	;  | 
SWITCHC1OFF:	SEC			;  | 
		SBC CHAIN1X,x		;  | 
		BRA ENDOFFSWITCHC1	;  | 
NOSWITCHC1OFF:	CLC			;  | 
		ADC.w CHAIN1X,x		;  | 
ENDOFFSWITCHC1:	PLY			;  |
		PLX			; /
		STA $0300,y		; set tile's X position
		LDA $01			; get sprite's Y position
		PHY			; \
		LDY $02			;  | offset by
		BNE NO_FLIP_1C2		;  | this tile's
		SEC			;  | Y position
		SBC.w DNMC_YPOS,x		;  | (add or
		BRA END_FLIP_1C2	;  | subtract
NO_FLIP_1C2:	CLC			;  | depending on
		ADC.w DNMC_YPOS,x		;  | flip)
END_FLIP_1C2:	PLY			; /
		PHX			; \
		LDX $15E9		;  | offset by
		PHA			;  | chain's Y
		LDA !OFFSET,x		;  | position
		TAX			;  | (add or
		PLA			;  | subtract
		PHY			;  | depending on
		LDY $02			;  | direction)
		BNE NOSWITCHC1OFF2	;  | 
SWITCHC1OFF2:	SEC			;  | 
		SBC.w CHAIN1Y,x		;  | 
		BRA ENDOFFSWITCHC12	;  | 
NOSWITCHC1OFF2:	CLC			;  | 
		ADC.w CHAIN1Y,x		;  | 
ENDOFFSWITCHC12:	PLY			;  |
		PLX			; /
		STA $0301,y		; set tile's Y position
		LDA !TEMP_FOR_TILE	; load tile # from scratch RAM
		CLC			; \ shift tile right/down
		ADC.w DNMC_TILES,x	; / according to which part
		STA $0302,y		; set tile #
		PHX			; back up X (index to tile data)
		LDX $15E9		; load X with index to sprite
		LDA $15F6,x		; load palette info
		ORA.b #%00000001		; always 2nd GFX page for dynamic sprites
		PHX			; \
		LDX $02			;  | flip the tile
		BNE NO_FLIP_1CHN	;  | if the sprite
		ORA.b #%11000000		;  | is flipped
NO_FLIP_1CHN:	PLX			; /
		ORA $64			; add in priority bits
		STA $0303,y		; set extra info
		PLX			; load backed up X
		INC !TILESDRAWN		; another tile was drawn
		INY			; \
		INY			;  | index to next slot
		INY			;  |
		INY			; /
		INX			; next tile to draw
		JMP TILELP		; loop (BRA is out of range)
RETFRML:		PLX			; load backed up X
		RTS

DRAW_CHAIN2:	PHX			; back up X
		LDX #$00		; load X with zero
TILELP2:		CPX #$04		; end of loop?
		BNE NORETFRML2		; if not, then don't end
		JMP RETFRML2		; if so, then JMP to end (BRA is out of range)
NORETFRML2:
		LDA $00			; get sprite's X position
		PHY			; \
		LDY $02			;  | offset by
		BNE NO_FLIP_2C		;  | this tile's
		SEC			;  | X position
		SBC.w DNMC_XPOS,x		;  | (add or
		BRA END_FLIP_2C		;  | subtract
NO_FLIP_2C:	CLC			;  | depending on
		ADC.w DNMC_XPOS,x		;  | flip)
END_FLIP_2C:	PLY			; /
		PHX			; \
		LDX $15E9		;  | offset by
		PHA			;  | chain's X
		LDA !OFFSET,x		;  | position
		TAX			;  | (add or
		PLA			;  | subtract
		PHY			;  | depending on
		LDY $02			;  | direction)
		BNE NOSWITCHC2OFF	;  | 
SWITCHC2OFF:	SEC			;  | 
		SBC.w CHAIN2X,x		;  | 
		BRA ENDOFFSWITCHC2	;  | 
NOSWITCHC2OFF:	CLC			;  | 
		ADC.w CHAIN2X,x		;  | 
ENDOFFSWITCHC2:	PLY			;  |
		PLX			; /
		STA $0300,y		; set tile's X position
		LDA $01			; get sprite's Y position
		PHY			; \
		LDY $02			;  | offset by
		BNE NO_FLIP_2C2		;  | this tile's
		SEC			;  | Y position
		SBC.w DNMC_YPOS,x		;  | (add or
		BRA END_FLIP_2C2	;  | subtract
NO_FLIP_2C2:	CLC			;  | depending on
		ADC.w DNMC_YPOS,x		;  | flip)
END_FLIP_2C2:	PLY			; /
		PHX			; \
		LDX $15E9		;  | offset by
		PHA			;  | chain's Y
		LDA !OFFSET,x		;  | position
		TAX			;  | (add or
		PLA			;  | subtract
		PHY			;  | depending on
		LDY $02			;  | direction)
		BNE NOSWITCHC2OFF2	;  | 
SWITCHC2OFF2:	SEC			;  | 
		SBC.w CHAIN2Y,x		;  | 
		BRA ENDOFFSWITCHC22	;  | 
NOSWITCHC2OFF2:	CLC			;  | 
		ADC.w CHAIN2Y,x		;  | 
ENDOFFSWITCHC22:	PLY			;  |
		PLX			; /
		STA $0301,y		; set tile's Y position
		LDA !TEMP_FOR_TILE	; load tile # from scratch RAM
		CLC			; \ shift tile right/down
		ADC.w DNMC_TILES,x	; / according to which part
		STA $0302,y		; set tile #
		PHX			; back up X (index to tile data)
		LDX $15E9		; load X with index to sprite
		LDA $15F6,x		; load palette info
		ORA.b #%00000001		; always 2nd GFX page for dynamic sprites
		PHX			; \
		LDX $02			;  | flip the tile
		BNE NO_FLIP_2CHN	;  | if the sprite
		ORA.b #%11000000		;  | is flipped
NO_FLIP_2CHN:	PLX			; /
		ORA $64			; add in priority bits
		STA $0303,y		; set extra info
		PLX			; load backed up X
		INC !TILESDRAWN		; another tile was drawn
		INY			; \
		INY			;  | index to next slot
		INY			;  |
		INY			; /
		INX			; next tile to draw
		JMP TILELP2		; loop (BRA is out of range)
RETFRML2:	PLX			; load backed up X
		RTS

DRAW_BALL:	PHX			; back up X
		LDX #$00		; load X with zero
TILELP3:		CPX #$04		; end of loop?
		BNE NORETFRML3		; if not, then don't end
		JMP RETFRML3		; if so, then JMP to end (BRA is out of range)
NORETFRML3:
		LDA $00			; get sprite's X position
		PHY			; \
		LDY $02			;  | offset by
		BNE NO_FLIP_B		;  | this tile's
		SEC			;  | X position
		SBC.w DNMC_XPOS,x		;  | (add or
		BRA END_FLIP_B		;  | subtract
NO_FLIP_B:	CLC			;  | depending on
		ADC.w DNMC_XPOS,x		;  | flip)
END_FLIP_B:	PLY			; /
		PHX			; \
		LDX $15E9		;  | offset by
		PHA			;  | ball's X
		LDA !OFFSET,x		;  | position
		TAX			;  | (add or
		PLA			;  | subtract
		PHY			;  | depending on
		LDY $02			;  | direction)
		BNE NOSWITCHBOFF	;  | 
SWITCHBOFF:	SEC			;  | 
		SBC.w BALL_X,x		;  | 
		BRA ENDOFFSWITCHB	;  | 
NOSWITCHBOFF:	CLC			;  | 
		ADC.w BALL_X,x		;  | 
ENDOFFSWITCHB:	PLY			;  |
		PLX			; /
		STA $0300,y		; set tile's X position
		LDA $01			; get sprite's Y position
		PHY			; \
		LDY $02			;  | offset by
		BNE NO_FLIP_B2		;  | this tile's
		SEC			;  | Y position
		SBC.w DNMC_YPOS,x		;  | (add or
		BRA END_FLIP_B2		;  | subtract
NO_FLIP_B2:	CLC			;  | depending on
		ADC.w DNMC_YPOS,x		;  | flip)
END_FLIP_B2:	PLY			; /
		PHX			; \
		LDX $15E9		;  | offset by
		PHA			;  | ball's Y
		LDA !OFFSET,x		;  | position
		TAX			;  | (add or
		PLA			;  | subtract
		PHY			;  | depending on
		LDY $02			;  | direction)
		BNE NOSWITCHBOFF2	;  | 
SWITCHBOFF2:	SEC			;  | 
		SBC.w BALL_Y,x		;  | 
		BRA ENDOFFSWITCHB2	;  | 
NOSWITCHBOFF2:	CLC			;  | 
		ADC.w BALL_Y,x		;  | 
ENDOFFSWITCHB2:	PLY			;  |
		PLX			; /
		STA $0301,y		; set tile's Y position
		LDA !TEMP_FOR_TILE_2	; load tile # from scratch RAM
		CLC			; \ shift tile right/down
		ADC.w DNMC_TILES,x	; / according to which part
		STA $0302,y		; set tile #
		PHX			; back up X (index to tile data)
		LDX $15E9		; load X with index to sprite
		LDA $15F6,x		; load palette info
		ORA.b #%00000001		; always 2nd GFX page for dynamic sprites
		PHX			; \
		LDX $02			;  | flip the tile
		BNE NO_FLIP_BALL	;  | if the sprite
		ORA.b #%11000000		;  | is flipped
NO_FLIP_BALL:	PLX			; /
		ORA $64			; add in priority bits
		STA $0303,y		; set extra info
		PLX			; load backed up X
		INC !TILESDRAWN		; another tile was drawn
		INY			; \
		INY			;  | index to next slot
		INY			;  |
		INY			; /
		INX			; next tile to draw
		JMP TILELP3		; loop (BRA is out of range)
RETFRML3:	PLX			; load backed up X
		RTS

SETTILES:	LDA !TILESDRAWN		; \ don't reserve
		BEQ NODRAW		; / if no tiles
		LDY #$02		; #$02 means 16x16
		DEC A			; A = # tiles - 1
		JSL $81B7B3		; don't draw if offscreen
NODRAW:		RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Dynamic sprite routine
; Programmed mainly by SMKDan, but based on some of my code
;
; NOTE: this one is slightly modified to use manually inserted GFX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SLOTS: db $CC,$C8,$C4,$C0	;avaliable slots.  Any more transfers and it's overflowing by a dangerous amount.

GETSLOT:
	PHY		;preserve OAM index
	PHA		;preserve frame
	LDA !SLOTSUSED	;test if slotsused == maximum allowed
	CMP #!MAXSLOTS
	BEQ NoneFree

	PLA		;pop frame
	REP #$20	;16bit A
	AND #$00FF	;wipe high
	XBA		;<< 8
	LSR A		;>> 1 = << 7
	STA !TEMP	;back to scratch
	LDA.w #!GFXADDR
	CLC
	ADC !TEMP	;add frame offset	
	STA !SLOTPTR	;store to pointer to be used at transfer time
	SEP #$20	;8bit store
	LDA.b #!GFXADDR/$10000
	CLC
	ADC !BANKTEMP
	STA !SLOTBANK	;store bank to 24bit pointer

	LDY !SLOTSUSED	;calculate VRAM address + tile number
	LDA SLOTS,y	;get tile# in VRAM
	PHA		;preserve for eventual pull
	SEC
	SBC #$C0	;starts at C0h, they start at C0 in tilemap
	REP #$20	;16bit math
	AND #$00FF	;wipe high byte
	ASL #5		;multiply by 32, since 32 bytes/16 words equates to 1 32bytes tile
	CLC
	ADC #$0B44	;add 0B44, base address of buffer	
	STA !SLOTDEST	;destination address in the buffer

	JSR DMABUFFER	;ROM -> RAM copy

	SEP #$20	;8bit A	
	INC !SLOTSUSED	;one extra slot has been used

	PLA		;return starting tile number
	PLY
	RTS
		
NoneFree:
	PLA
	PLY
	LDA #$00	;zero on no free slots
	RTS

;;;;;;;;;;;;;;;;
;Transfer routine
;;;;;;;;;;;;;;;;

;DMA ROM -> RAM ROUTINE

DMABUFFER:
;set destination RAM address
	REP #$20
	LDA !SLOTDEST
	STA $2181	;16bit RAM dest
	LDY #$7F
	STY $2183	;set 7F as bank

;common DMA settings
	STZ $4300	;1 reg only
	LDY #$80	;to 2180, RAM write/read
	STY $4301

;first line
	LDA !SLOTPTR
	STA $4302	;low 16bits
	LDY !SLOTBANK
	STY $4304	;bank
	LDY #$80	;128 bytes
	STY $4305
	LDY #$01
	STY $420B	;transfer

;second line
	LDA !SLOTDEST	;update buffer dest
	CLC
	ADC #$0200	;512 byte rule for sprites
	STA !SLOTDEST	;updated base
	STA $2181	;updated RAM address

	LDA !SLOTPTR	;update source address
	CLC
	ADC #$0200	;512 bytes, next row
	STA !SLOTPTR
	STA $4302	;low 16bits
	LDY !SLOTBANK
	STY $4304	;bank
	LDY #$80
	STY $4305
	LDY #$01
	STY $420B	;transfer

;third line
	LDA !SLOTDEST	;update buffer dest
	CLC
	ADC #$0200	;512 byte rule for sprites
	STA !SLOTDEST	;updated base
	STA $2181	;updated RAM address

	LDA !SLOTPTR	;update
	CLC
	ADC #$0200
	STA !SLOTPTR
	STA $4302
	LDY !SLOTBANK
	STY $4304
	LDY #$80
	STY $4305
	LDY #$01
	STY $420B	;transfer

;fourth line
	LDA !SLOTDEST	;update buffer dest
	CLC
	ADC #$0200	;512 byte rule for sprites
	STA !SLOTDEST	;updated base
	STA $2181	;updated RAM address

	LDA !SLOTPTR
	CLC
	ADC #$0200
	STA !SLOTPTR
	STA $4302
	LDY !SLOTBANK
	STY $4304
	LDY #$80
	STY $4305
	LDY #$01
	STY $420B

	SEP #$20	;8bit A
	RTS		;all done, return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; This will convert a frame offset
;; into a pointer for a dynamic frame
;;   OFFSETS:
;;   00 01 02 03
;;   04 05 06 07
;;   08 09 0A 0B
;;   0C 0D 0E 0F
;;
;;   FRAMES:
;;   00 01 02 03
;;   10 11 12 13
;;   20 21 22 23
;;   30 31 32 33
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		!OFF2FRM_TEMP = $05

OFF2FRM:		PHY
		STA !OFF2FRM_TEMP
		AND.b #%00000011
		TAY
		LDA !OFF2FRM_TEMP	
		ASL A
		ASL A
		AND.b #%11110000
		STY !OFF2FRM_TEMP
		ORA !OFF2FRM_TEMP
		PLY
		RTS
		
dl Init,Main